diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/txop.h ns-3.34/src/wifi/model/txop.h
--- ns-3.33/src/wifi/model/txop.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/txop.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,7 +22,6 @@
 #define TXOP_H
 
 #include "ns3/traced-value.h"
-#include "mac-low-transmission-parameters.h"
 #include "wifi-mac-header.h"
 
 namespace ns3 {
@@ -30,14 +29,14 @@
 class Packet;
 class ChannelAccessManager;
 class MacTxMiddle;
-class MacLow;
 class WifiMode;
 class WifiMacQueue;
 class WifiMacQueueItem;
 class UniformRandomVariable;
 class CtrlBAckResponseHeader;
 class WifiRemoteStationManager;
-class WifiTxVector;
+enum WifiMacDropReason : uint8_t;  // opaque enum declaration
+enum AcIndex : uint8_t;
 
 /**
  * \brief Handle packet fragmentation and retransmissions
@@ -79,20 +78,19 @@
   static TypeId GetTypeId (void);
 
   /**
-   * typedef for a callback to invoke when a
-   * packet transmission was completed successfully.
+   * typedef for a callback to invoke when an MPDU is dropped.
    */
-  typedef Callback <void, const WifiMacHeader&> TxOk;
-  /**
-   * typedef for a callback to invoke when a
-   * packet transmission was failed.
-   */
-  typedef Callback <void, const WifiMacHeader&> TxFailed;
+  typedef Callback <void, WifiMacDropReason, Ptr<const WifiMacQueueItem> > DroppedMpdu;
+
   /**
-   * typedef for a callback to invoke when a
-   * packet is dropped.
+   * Enumeration for channel access status
    */
-  typedef Callback <void, Ptr<const Packet> > TxDropped;
+  enum ChannelAccessStatus
+  {
+    NOT_REQUESTED = 0,
+    REQUESTED,
+    GRANTED
+  };
 
   /**
    * Check for QoS TXOP.
@@ -100,13 +98,13 @@
    * \returns true if QoS TXOP.
    */
   virtual bool IsQosTxop () const;
-
   /**
-   * Set MacLow associated with this Txop.
+   * Get the access category.
    *
-   * \param low MacLow to associate.
+   * \return the access category.
    */
-  void SetMacLow (const Ptr<MacLow> low);
+  virtual AcIndex GetAccessCategory (void) const;
+
   /**
    * Set ChannelAccessManager this Txop is associated to.
    *
@@ -127,27 +125,9 @@
   void SetTxMiddle (const Ptr<MacTxMiddle> txMiddle);
 
   /**
-   * \param callback the callback to invoke when a
-   * packet transmission was completed successfully.
-   */
-  void SetTxOkCallback (TxOk callback);
-  /**
-   * \param callback the callback to invoke when a
-   *        packet transmission was completed unsuccessfully.
+   * \param callback the callback to invoke when an MPDU is dropped
    */
-  void SetTxFailedCallback (TxFailed callback);
-  /**
-   * \param callback the callback to invoke when a
-   *        packet is dropped.
-   */
-  void SetTxDroppedCallback (TxDropped callback);
-
-  /**
-   * Return the MacLow associated with this Txop.
-   *
-   * \return the associated MacLow
-   */
-  Ptr<MacLow> GetLow (void) const;
+  virtual void SetDroppedMpduCallback (DroppedMpdu callback);
 
   /**
    * Return the packet queue associated with this Txop.
@@ -205,6 +185,19 @@
    * \return the TXOP limit.
    */
   Time GetTxopLimit (void) const;
+  /**
+   * Update the value of the CW variable to take into account
+   * a transmission success or a transmission abort (stop transmission
+   * of a packet after the maximum number of retransmissions has been
+   * reached). By default, this resets the CW variable to minCW.
+   */
+  void ResetCw (void);
+  /**
+   * Update the value of the CW variable to take into account
+   * a transmission failure. By default, this triggers a doubling
+   * of CW (capped by maxCW).
+   */
+  void UpdateFailedCw (void);
 
   /**
    * When a channel switching occurs, enqueued packets are removed.
@@ -239,91 +232,17 @@
   virtual void Queue (Ptr<Packet> packet, const WifiMacHeader &hdr);
 
   /**
-   * Sends CF frame to STA with address <i>addr</i>.
-   *
-   * \param frameType the type of frame to be transmitted.
-   * \param addr address of the recipient.
-   */
-  void SendCfFrame (WifiMacType frameType, Mac48Address addr);
-
-  /* Event handlers */
-  /**
-   * Event handler when a CTS timeout has occurred.
-   */
-  virtual void MissedCts (void);
-  /**
-   * Event handler when an Ack is received.
-   */
-  virtual void GotAck (void);
-  /**
-   * Event handler when an Ack is missed.
-   */
-  virtual void MissedAck (void);
-  /**
-   * Event handler when a CF-END frame is received.
-   */
-  void GotCfEnd (void);
-  /**
-   * Event handler when a response to a CF-POLL frame is missed.
-   *
-   * \param expectedCfAck flag to indicate whether a CF-Ack was expected in the response.
-   */
-  void MissedCfPollResponse (bool expectedCfAck);
-  /**
-   * Event handler when a BlockAck is received.
-   *
-   * \param blockAck BlockAck header.
-   * \param recipient address of the recipient.
-   * \param rxSnr SNR of the BlockAck itself in linear scale.
-   * \param dataSnr reported data SNR from the peer in linear scale.
-   * \param dataTxVector TXVECTOR used to send the Data.
-   */
-  virtual void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient,
-                            double rxSnr, double dataSnr, WifiTxVector dataTxVector);
-  /**
-   * Event handler when a BlockAck timeout has occurred.
-   * \param nMpdus the number of MPDUs sent in the A-MPDU transmission that results in a BlockAck timeout.
-   */
-  virtual void MissedBlockAck (uint8_t nMpdus);
-
-  /**
-   * Start transmission for the next fragment.
-   * This is called for fragment only.
-   */
-  virtual void StartNextFragment (void);
-  /**
-   * Cancel the transmission.
-   */
-  virtual void Cancel (void);
-  /**
-   * Start transmission for the next packet if allowed by the TxopLimit.
-   */
-  virtual void StartNextPacket (void);
-  /**
-   * Event handler when a transmission that
-   * does not require an Ack has completed.
-   */
-  virtual void EndTxNoAck (void);
-
-  /**
-   * Return the remaining duration in the current TXOP.
+   * Called by the FrameExchangeManager to notify that channel access has
+   * been granted for the given amount of time.
    *
-   * \return the remaining duration in the current TXOP.
+   * \param txopDuration the duration of the TXOP gained (zero for DCF)
    */
-  virtual Time GetTxopRemaining (void) const;
+  virtual void NotifyChannelAccessed (Time txopDuration = Seconds (0));
   /**
-   * Update backoff and restart access if needed.
+   * Called by the FrameExchangeManager to notify the completion of the transmissions.
+   * This method generates a new backoff and restarts access if needed.
    */
-  virtual void TerminateTxop (void);
-
-  /**
-   * Check if the next PCF transmission can fit in the remaining CFP duration.
-   *
-   * \return true if the next PCF transmission can fit in the remaining CFP duration,
-   *         false otherwise
-   */
-  bool CanStartNextPolling (void) const;
-
+  virtual void NotifyChannelReleased (void);
 
   /**
    * Assign a fixed random variable stream number to the random variables
@@ -337,10 +256,9 @@
   int64_t AssignStreams (int64_t stream);
 
   /**
-   * \returns true if access has been requested for this function and
-   *          has not been granted already, false otherwise.
+   * \return the current channel access status.
    */
-  virtual bool IsAccessRequested (void) const;
+  virtual ChannelAccessStatus GetAccessStatus (void) const;
 
   /**
    * \param nSlots the number of slots of the backoff.
@@ -354,8 +272,8 @@
   ///< ChannelAccessManager associated class
   friend class ChannelAccessManager;
 
-  virtual void DoDispose (void);
-  virtual void DoInitialize (void);
+  void DoDispose (void) override;
+  void DoInitialize (void) override;
 
   /* Txop notifications forwarded here */
   /**
@@ -363,10 +281,6 @@
    */
   virtual void NotifyAccessRequested (void);
   /**
-   * Notify the Txop that access has been granted.
-   */
-  virtual void NotifyAccessGranted (void);
-  /**
    * Notify the Txop that internal collision has occurred.
    */
   virtual void NotifyInternalCollision (void);
@@ -381,13 +295,13 @@
    */
   virtual void GenerateBackoff (void);
   /**
-   * Restart access request if needed.
-   */
-  virtual void RestartAccessIfNeeded (void);
-  /**
    * Request access from Txop if needed.
    */
   virtual void StartAccessIfNeeded (void);
+  /**
+   * Request access to the ChannelAccessManager
+   */
+  void RequestAccess (void);
 
   /**
    * \returns the current value of the CW variable. The initial value is
@@ -395,19 +309,6 @@
    */
   uint32_t GetCw (void) const;
   /**
-   * Update the value of the CW variable to take into account
-   * a transmission success or a transmission abort (stop transmission
-   * of a packet after the maximum number of retransmissions has been
-   * reached). By default, this resets the CW variable to minCW.
-   */
-  void ResetCw (void);
-  /**
-   * Update the value of the CW variable to take into account
-   * a transmission failure. By default, this triggers a doubling
-   * of CW (capped by maxCW).
-   */
-  void UpdateFailedCw (void);
-  /**
    * Return the current number of backoff slots.
    *
    * \return the current number of backoff slots
@@ -427,97 +328,19 @@
    */
   void UpdateBackoffSlotsNow (uint32_t nSlots, Time backoffUpdateBound);
 
-  /**
-   * Check if RTS should be re-transmitted if CTS was missed.
-   *
-   * \param packet current packet being transmitted.
-   * \param hdr current header being transmitted.
-   * \return true if RTS should be re-transmitted,
-   *         false otherwise.
-   */
-  bool NeedRtsRetransmission (Ptr<const Packet> packet, const WifiMacHeader &hdr);
-  /**
-   * Check if Data should be re-transmitted if Ack was missed.
-   *
-   * \param packet current packet being transmitted.
-   * \param hdr current header being transmitted.
-   * \return true if Data should be re-transmitted,
-   *         false otherwise.
-   */
-  bool NeedDataRetransmission (Ptr<const Packet> packet, const WifiMacHeader &hdr);
-  /**
-   * Check if the current packet should be fragmented.
-   *
-   * \return true if the current packet should be fragmented,
-   *         false otherwise
-   */
-  virtual bool NeedFragmentation (void) const;
-
-  /**
-   * Continue to the next fragment. This method simply
-   * increments the internal variable that keep track
-   * of the current fragment number.
-   */
-  void NextFragment (void);
-  /**
-   * Get the next fragment from the packet with
-   * appropriate Wifi header for the fragment.
-   *
-   * \param hdr Wi-Fi header.
-   *
-   * \return the fragment with the current fragment number.
-   */
-  virtual Ptr<Packet> GetFragmentPacket (WifiMacHeader *hdr);
-  /**
-   * Calculate the size of the next fragment.
-   *
-   * \return the size of the next fragment in bytes.
-   */
-  virtual uint32_t GetNextFragmentSize (void) const;
-  /**
-   * Calculate the size of the current fragment.
-   *
-   * \return the size of the current fragment in bytes.
-   */
-  virtual uint32_t GetFragmentSize (void) const;
-  /**
-   * Calculate the offset for the current fragment.
-   *
-   * \return the offset for the current fragment in bytes.
-   */
-  virtual uint32_t GetFragmentOffset (void) const;
-  /**
-   * Check if the current fragment is the last fragment.
-   *
-   * \return true if the current fragment is the last fragment,
-   *         false otherwise.
-   */
-  virtual bool IsLastFragment (void) const;
-  /**
-   *
-   * Pass the packet included in the wifi MAC queue item to the
-   * packet dropped callback.
-   *
-   * \param item the wifi MAC queue item.
-   */
-  void TxDroppedPacket (Ptr<const WifiMacQueueItem> item);
-
   Ptr<ChannelAccessManager> m_channelAccessManager; //!< the channel access manager
-  TxOk m_txOkCallback;                              //!< the transmit OK callback
-  TxFailed m_txFailedCallback;                      //!< the transmit failed callback
-  TxDropped m_txDroppedCallback;                    //!< the packet dropped callback
+  DroppedMpdu m_droppedMpduCallback;                //!< the dropped MPDU callback
   Ptr<WifiMacQueue> m_queue;                        //!< the wifi MAC queue
   Ptr<MacTxMiddle> m_txMiddle;                      //!< the MacTxMiddle
-  Ptr <MacLow> m_low;                               //!< the MacLow
   Ptr<WifiRemoteStationManager> m_stationManager;   //!< the wifi remote station manager
   Ptr<UniformRandomVariable> m_rng;                 //!< the random stream
 
-  uint32_t m_cwMin;        //!< the minimum contention window
-  uint32_t m_cwMax;        //!< the maximum contention window
-  uint32_t m_cw;           //!< the current contention window
-  uint32_t m_backoff;      //!< the current backoff
-  bool m_accessRequested;  //!< flag whether channel access is already requested
-  uint32_t m_backoffSlots; //!< the number of backoff slots
+  uint32_t m_cwMin;              //!< the minimum contention window
+  uint32_t m_cwMax;              //!< the maximum contention window
+  uint32_t m_cw;                 //!< the current contention window
+  uint32_t m_backoff;            //!< the current backoff
+  ChannelAccessStatus m_access;  //!< channel access status
+  uint32_t m_backoffSlots;       //!< the number of backoff slots
   /**
    * the backoffStart variable is used to keep track of the
    * time at which a backoff was started or the time at which
@@ -528,10 +351,6 @@
   uint8_t m_aifsn;        //!< the AIFSN
   Time m_txopLimit;       //!< the TXOP limit time
 
-  Ptr<const Packet> m_currentPacket;            //!< the current packet
-  WifiMacHeader m_currentHdr;                   //!< the current header
-  MacLowTransmissionParameters m_currentParams; //!< current transmission parameters
-  uint8_t m_fragmentNumber;                     //!< the fragment number
   TracedCallback<uint32_t> m_backoffTrace;      //!< backoff trace value
   TracedValue<uint32_t> m_cwTrace;              //!< CW trace value
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-capabilities.cc ns-3.34/src/wifi/model/vht/vht-capabilities.cc
--- ns-3.33/src/wifi/model/vht/vht-capabilities.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-capabilities.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,426 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Ghada Badawy <gbadawy@rim.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "vht-capabilities.h"
+
+namespace ns3 {
+
+VhtCapabilities::VhtCapabilities ()
+  : m_maxMpduLength (0),
+    m_supportedChannelWidthSet (0),
+    m_rxLdpc (0),
+    m_shortGuardIntervalFor80Mhz (0),
+    m_shortGuardIntervalFor160Mhz (0),
+    m_txStbc (0),
+    m_rxStbc (0),
+    m_suBeamformerCapable (0),
+    m_suBeamformeeCapable (0),
+    m_beamformeeStsCapable (0),
+    m_numberOfSoundingDimensions (0),
+    m_muBeamformerCapable (0),
+    m_muBeamformeeCapable (0),
+    m_vhtTxopPs (0),
+    m_htcVhtCapable (0),
+    m_maxAmpduLengthExponent (0),
+    m_vhtLinkAdaptationCapable (0),
+    m_rxAntennaPatternConsistency (0),
+    m_txAntennaPatternConsistency (0),
+    m_rxHighestSupportedLongGuardIntervalDataRate (0),
+    m_txHighestSupportedLongGuardIntervalDataRate (0),
+    m_vhtSupported (0)
+{
+  m_rxMcsMap.resize (8,0);
+  m_txMcsMap.resize (8,0);
+  for (uint8_t i = 0; i < 8; i++) //set to 3 by default, i.e. #spatial streams not supported. 0 means supported up to MCS 7, not what we want to imply at this stage.
+    {
+      m_rxMcsMap[i] = 3;
+      m_txMcsMap[i] = 3;
+    }
+}
+
+WifiInformationElementId
+VhtCapabilities::ElementId () const
+{
+  return IE_VHT_CAPABILITIES;
+}
+
+void
+VhtCapabilities::SetVhtSupported (uint8_t vhtSupported)
+{
+  m_vhtSupported = vhtSupported;
+}
+
+uint8_t
+VhtCapabilities::GetInformationFieldSize () const
+{
+  //we should not be here if vht is not supported
+  NS_ASSERT (m_vhtSupported > 0);
+  return 12;
+}
+
+Buffer::Iterator
+VhtCapabilities::Serialize (Buffer::Iterator i) const
+{
+  if (m_vhtSupported < 1)
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+VhtCapabilities::GetSerializedSize () const
+{
+  if (m_vhtSupported < 1)
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+VhtCapabilities::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (m_vhtSupported == 1)
+    {
+      //write the corresponding value for each bit
+      start.WriteHtolsbU32 (GetVhtCapabilitiesInfo ());
+      start.WriteHtolsbU64 (GetSupportedMcsAndNssSet ());
+    }
+}
+
+uint8_t
+VhtCapabilities::DeserializeInformationField (Buffer::Iterator start,
+                                              uint8_t length)
+{
+  Buffer::Iterator i = start;
+  uint32_t vhtinfo = i.ReadLsbtohU32 ();
+  uint64_t mcsset = i.ReadLsbtohU64 ();
+  SetVhtCapabilitiesInfo (vhtinfo);
+  SetSupportedMcsAndNssSet (mcsset);
+  return length;
+}
+
+void
+VhtCapabilities::SetVhtCapabilitiesInfo (uint32_t ctrl)
+{
+  m_maxMpduLength = ctrl & 0x03;
+  m_supportedChannelWidthSet = (ctrl >> 2) & 0x03;
+  m_rxLdpc = (ctrl >> 4) & 0x01;
+  m_shortGuardIntervalFor80Mhz = (ctrl >> 5) & 0x01;
+  m_shortGuardIntervalFor160Mhz = (ctrl >> 6) & 0x01;
+  m_txStbc = (ctrl >> 7) & 0x01;
+  m_rxStbc = (ctrl >> 8) & 0x07;
+  m_suBeamformerCapable = (ctrl >> 11) & 0x01;
+  m_suBeamformeeCapable = (ctrl >> 12) & 0x01;
+  m_beamformeeStsCapable = (ctrl >> 13) & 0x07;
+  m_numberOfSoundingDimensions = (ctrl >> 16) & 0x07;
+  m_muBeamformerCapable = (ctrl >> 19) & 0x01;
+  m_muBeamformeeCapable = (ctrl >> 20) & 0x01;
+  m_vhtTxopPs = (ctrl >> 21) & 0x01;
+  m_htcVhtCapable = (ctrl >> 22) & 0x01;
+  m_maxAmpduLengthExponent = (ctrl >> 23) & 0x07;
+  m_vhtLinkAdaptationCapable = (ctrl >> 26) & 0x03;
+  m_rxAntennaPatternConsistency = (ctrl >> 28) & 0x01;
+  m_txAntennaPatternConsistency = (ctrl >> 29) & 0x01;
+}
+
+uint32_t
+VhtCapabilities::GetVhtCapabilitiesInfo () const
+{
+  uint32_t val = 0;
+  val |= m_maxMpduLength & 0x03;
+  val |= (m_supportedChannelWidthSet & 0x03) << 2;
+  val |= (m_rxLdpc & 0x01) << 4;
+  val |= (m_shortGuardIntervalFor80Mhz & 0x01) << 5;
+  val |= (m_shortGuardIntervalFor160Mhz & 0x01) << 6;
+  val |= (m_txStbc & 0x01) << 7;
+  val |= (m_rxStbc & 0x07) << 8;
+  val |= (m_suBeamformerCapable & 0x01) << 11;
+  val |= (m_suBeamformeeCapable & 0x01) << 12;
+  val |= (m_beamformeeStsCapable & 0x07) << 13;
+  val |= (m_numberOfSoundingDimensions & 0x07) << 16;
+  val |= (m_muBeamformerCapable & 0x01) << 19;
+  val |= (m_muBeamformeeCapable & 0x01) << 20;
+  val |= (m_vhtTxopPs & 0x01) << 21;
+  val |= (m_htcVhtCapable & 0x01) << 22;
+  val |= (m_maxAmpduLengthExponent & 0x07) << 23;
+  val |= (m_vhtLinkAdaptationCapable & 0x03) << 26;
+  val |= (m_rxAntennaPatternConsistency & 0x01) << 28;
+  val |= (m_txAntennaPatternConsistency & 0x01) << 29;
+  return val;
+}
+
+void
+VhtCapabilities::SetSupportedMcsAndNssSet (uint64_t ctrl)
+{
+  uint16_t n;
+  for (uint8_t i = 0; i < 8; i++)
+    {
+      n = i * 2;
+      m_rxMcsMap[i] = (ctrl >> n) & 0x03;
+    }
+  m_rxHighestSupportedLongGuardIntervalDataRate = (ctrl >> 16) & 0x1fff;
+  for (uint8_t i = 0; i < 8; i++)
+    {
+      n = (i * 2) + 32;
+      m_txMcsMap[i] = (ctrl >> n) & 0x03;
+    }
+  m_txHighestSupportedLongGuardIntervalDataRate = (ctrl >> 48) & 0x1fff;
+}
+
+uint64_t
+VhtCapabilities::GetSupportedMcsAndNssSet () const
+{
+  uint64_t val = 0;
+  uint16_t n;
+  for (uint8_t i = 0; i < 8; i++)
+    {
+      n = i * 2;
+      val |= (static_cast<uint64_t> (m_rxMcsMap[i]) & 0x03) << n;
+    }
+  val |=  (static_cast<uint64_t> (m_rxHighestSupportedLongGuardIntervalDataRate) & 0x1fff) << 16;
+  for (uint8_t i = 0; i < 8; i++)
+    {
+      n = (i * 2) + 32;
+      val |= (static_cast<uint64_t> (m_txMcsMap[i]) & 0x03) << n;
+    }
+  val |= (static_cast<uint64_t> (m_txHighestSupportedLongGuardIntervalDataRate) & 0x1fff) << 48;
+  return val;
+}
+
+void
+VhtCapabilities::SetMaxMpduLength (uint16_t length)
+{
+  NS_ABORT_MSG_IF (length != 3895 && length != 7991 && length != 11454,
+                   "Invalid MPDU Max Length value");
+  if (length == 11454)
+    {
+      m_maxMpduLength = 2;
+    }
+  else if (length == 7991)
+    {
+      m_maxMpduLength = 1;
+    }
+  else
+    {
+      m_maxMpduLength = 0;
+    }
+}
+
+void
+VhtCapabilities::SetSupportedChannelWidthSet (uint8_t channelWidthSet)
+{
+  m_supportedChannelWidthSet = channelWidthSet;
+}
+
+void
+VhtCapabilities::SetRxLdpc (uint8_t rxLdpc)
+{
+  m_rxLdpc = rxLdpc;
+}
+
+void
+VhtCapabilities::SetShortGuardIntervalFor80Mhz (uint8_t shortGuardInterval)
+{
+  m_shortGuardIntervalFor80Mhz = shortGuardInterval;
+}
+
+void
+VhtCapabilities::SetShortGuardIntervalFor160Mhz (uint8_t shortGuardInterval)
+{
+  m_shortGuardIntervalFor160Mhz = shortGuardInterval;
+}
+
+void
+VhtCapabilities::SetRxStbc (uint8_t rxStbc)
+{
+  m_rxStbc = rxStbc;
+}
+
+void
+VhtCapabilities::SetTxStbc (uint8_t txStbc)
+{
+  m_txStbc = txStbc;
+}
+
+void
+VhtCapabilities::SetMaxAmpduLength (uint32_t maxampdulength)
+{
+  for (uint8_t i = 0; i <= 7; i++)
+    {
+      if ((1ul << (13 + i)) - 1 == maxampdulength)
+        {
+          m_maxAmpduLengthExponent = i;
+          return;
+        }
+    }
+  NS_ABORT_MSG ("Invalid A-MPDU Max Length value");
+}
+
+void
+VhtCapabilities::SetRxMcsMap (uint8_t mcs, uint8_t nss)
+{
+  //MCS index should be at least 7 and should not exceed 9
+  NS_ASSERT (mcs >= 7 && mcs <= 9);
+  m_rxMcsMap[nss - 1] = mcs - 7; //1 = MCS 8; 2 = MCS 9
+}
+
+void
+VhtCapabilities::SetTxMcsMap (uint8_t mcs, uint8_t nss)
+{
+  //MCS index should be at least 7 and should not exceed 9
+  NS_ASSERT (mcs >= 7 && mcs <= 9);
+  m_txMcsMap[nss - 1] = mcs - 7; //1 = MCS 8; 2 = MCS 9
+}
+
+bool
+VhtCapabilities::IsSupportedTxMcs (uint8_t mcs) const
+{
+  NS_ASSERT (mcs >= 0 && mcs <= 9);
+  if (mcs <= 7)
+    {
+      return true;
+    }
+  if (mcs == 8 && (m_txMcsMap[0] == 1 || m_txMcsMap[0] == 2))
+    {
+      return true;
+    }
+  if (mcs == 9 && m_txMcsMap[0] == 2)
+    {
+      return true;
+    }
+  return false;
+}
+
+bool
+VhtCapabilities::IsSupportedRxMcs (uint8_t mcs) const
+{
+  NS_ASSERT (mcs >= 0 && mcs <= 9);
+  if (mcs <= 7)
+    {
+      return true;
+    }
+  if (mcs == 8 && (m_rxMcsMap[0] == 1 || m_rxMcsMap[0] == 2))
+    {
+      return true;
+    }
+  if (mcs == 9 && m_rxMcsMap[0] == 2)
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+VhtCapabilities::SetRxHighestSupportedLgiDataRate (uint16_t supportedDatarate)
+{
+  m_rxHighestSupportedLongGuardIntervalDataRate = supportedDatarate;
+}
+
+void
+VhtCapabilities::SetTxHighestSupportedLgiDataRate (uint16_t supportedDatarate)
+{
+  m_txHighestSupportedLongGuardIntervalDataRate = supportedDatarate;
+}
+
+uint16_t
+VhtCapabilities::GetMaxMpduLength (void) const
+{
+  if (m_maxMpduLength == 0)
+    {
+      return 3895;
+    }
+  if (m_maxMpduLength == 1)
+    {
+      return 7991;
+    }
+  if (m_maxMpduLength == 2)
+    {
+      return 11454;
+    }
+  NS_ABORT_MSG ("The value 3 is reserved");
+}
+
+uint8_t
+VhtCapabilities::GetSupportedChannelWidthSet () const
+{
+  return m_supportedChannelWidthSet;
+}
+
+uint8_t
+VhtCapabilities::GetRxLdpc () const
+{
+  return m_rxLdpc;
+}
+
+uint8_t
+VhtCapabilities::GetRxStbc () const
+{
+  return m_rxStbc;
+}
+
+uint8_t
+VhtCapabilities::GetTxStbc () const
+{
+  return m_txStbc;
+}
+
+uint32_t
+VhtCapabilities::GetMaxAmpduLength (void) const
+{
+  return (1ul << (13 + m_maxAmpduLengthExponent)) - 1;
+}
+
+bool
+VhtCapabilities::IsSupportedMcs (uint8_t mcs, uint8_t nss) const
+{
+  //The MCS index starts at 0 and NSS starts at 1
+  if (mcs <= 7 && m_rxMcsMap[nss - 1] < 3)
+    {
+      return true;
+    }
+  if (mcs == 8 && m_rxMcsMap[nss - 1] > 0 && m_rxMcsMap[nss - 1] < 3)
+    {
+      return true;
+    }
+  if (mcs == 9 && m_rxMcsMap[nss - 1] == 2)
+    {
+      return true;
+    }
+  return false;
+}
+
+uint16_t
+VhtCapabilities::GetRxHighestSupportedLgiDataRate () const
+{
+  return m_rxHighestSupportedLongGuardIntervalDataRate;
+}
+
+std::ostream &
+operator << (std::ostream &os, const VhtCapabilities &vhtCapabilities)
+{
+  os <<  vhtCapabilities.GetVhtCapabilitiesInfo () << "|" << vhtCapabilities.GetSupportedMcsAndNssSet ();
+
+  return os;
+}
+
+} //namespace ns3
